with Ada.Unchecked_Deallocation;
with Ada.Calendar.Formatting;
package casendra.text_utils is 

   type Natural_Array is array (Positive range <>) of Natural;
   type Natural_Array_Access is access all Natural_Array;
   Epoch : constant Ada.Calendar.Time := Ada.Calendar.Formatting.Time_Of(1970, 1, 1, 0.0);
   function String_To_Natural_Array (Input : in String; Delimeter : in String) return Natural_Array;
   procedure Free is new Ada.Unchecked_Deallocation (Natural_Array, Natural_Array_Access);
   function Is_Signed (Text : in String) return Boolean is (Text(Text'First) = '-' or Text(Text'First) = '+');
   function Convert_Date_String (Self : in Long_Integer) return Ada.Calendar.Time;
   function Date_To_String (Date : Ada.Calendar.Time) return String;
   function Escape_Org_Characters (Text : in Unbounded_String) return Unbounded_String;
end casendra.text_utils; 
