with Interfaces.C;
package body Terminal_Manager is 
   package C renames Interfaces.C;
   
   protected body Manager_T is
      procedure Update is
         use type C.Int;
         use type C.Unsigned_Short;
         type Winsize_T is record
            Ws_Row     : C.Unsigned_Short;
            Ws_Col     : C.Unsigned_Short;
            Ws_Xpixel  : C.Unsigned_Short;
            Ws_Y_Pixel : C.Unsigned_Short;
         end record with Convention => C;
         
         Tiocgwinsz : constant := 16#5413#;
         
         function Term_Ioctl (Fd      :        C.Int;
                              Request :        C.Long;
                              Winsize : in out winsize_t) return C.Int 
         with Import, Convention => C, External_Name => "ioctl";
         
         Winsize : Winsize_T;
      begin
         if Term_Ioctl (2, Tiocgwinsz, Winsize) < 0 then
            raise Program_Error with "Ioctl failed";
         end if;
         if Winsize.Ws_Row > 0 then
            Height := Natural (Winsize.Ws_Row);
         end if;
         if Winsize.Ws_Col > 0 then
            Width := Natural (Winsize.Ws_Col);
         end if;

      end Update;
      
      function Get_Width return Natural is (Width);
      
      function Get_Height return Natural is (Height);
   end Manager_T;
begin
   Manager.Update;
end Terminal_Manager;

